using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Demo_16_System_Drawing
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox PictureBoxAnimation;
		private System.Timers.Timer TimerAnimation;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private int mPosX = 0;
		private int mPosY = 0;
		
		private int StepX = 1;
		private int StepY = 1;

		public const int ELLIPSE_SIZE_X = 70;
		public const int ELLIPSE_SIZE_Y = 40;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.TimerAnimation = new System.Timers.Timer();
			this.PictureBoxAnimation = new System.Windows.Forms.PictureBox();
			((System.ComponentModel.ISupportInitialize)(this.TimerAnimation)).BeginInit();
			this.SuspendLayout();
			// 
			// TimerAnimation
			// 
			this.TimerAnimation.Enabled = true;
			this.TimerAnimation.Interval = 10;
			this.TimerAnimation.SynchronizingObject = this;
			this.TimerAnimation.Elapsed += new System.Timers.ElapsedEventHandler(this.TimerAnimation_Elapsed);
			// 
			// PictureBoxAnimation
			// 
			this.PictureBoxAnimation.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.PictureBoxAnimation.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.PictureBoxAnimation.Location = new System.Drawing.Point(16, 16);
			this.PictureBoxAnimation.Name = "PictureBoxAnimation";
			this.PictureBoxAnimation.Size = new System.Drawing.Size(224, 160);
			this.PictureBoxAnimation.TabIndex = 0;
			this.PictureBoxAnimation.TabStop = false;
			this.PictureBoxAnimation.Paint += new System.Windows.Forms.PaintEventHandler(this.PictureBoxAnimation_Paint);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(256, 189);
			this.Controls.Add(this.PictureBoxAnimation);
			this.Name = "MainForm";
			this.Text = "System.Drawing Demo";
			((System.ComponentModel.ISupportInitialize)(this.TimerAnimation)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void TimerAnimation_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{
			mPosX += StepX;
			if ((mPosX >= PictureBoxAnimation.Width - ELLIPSE_SIZE_X - 3) || (mPosX <= 0))
			{
				StepX = -StepX;
			}

			mPosY += StepY;
			if ((mPosY >= PictureBoxAnimation.Height - ELLIPSE_SIZE_Y - 3) || (mPosY <= 0))
			{
				StepY = -StepY;
			}

			PictureBoxAnimation.Refresh();
		}

		private void PictureBoxAnimation_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics g = e.Graphics;
			g.SmoothingMode = SmoothingMode.AntiAlias;

			Brush brush = new SolidBrush(Color.Blue);
			g.FillEllipse(brush, mPosX, mPosY,
				ELLIPSE_SIZE_X, ELLIPSE_SIZE_Y);
			brush.Dispose();

			brush = new SolidBrush(Color.Yellow);
			Font font = new Font("Arial", 14, FontStyle.Bold);
			g.DrawString(".NET", font, brush, mPosX+10, mPosY+10);
			brush.Dispose();
			font.Dispose();
		}
	}
}
