using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Demo_21_Drag_and_Drop
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox ListBoxSource;
		private System.Windows.Forms.ListBox ListBoxTarget;
		private System.Windows.Forms.Label LabelDragSource;
		private System.Windows.Forms.Label LabelDropTarget;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ListBoxSource = new System.Windows.Forms.ListBox();
			this.ListBoxTarget = new System.Windows.Forms.ListBox();
			this.LabelDragSource = new System.Windows.Forms.Label();
			this.LabelDropTarget = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// ListBoxSource
			// 
			this.ListBoxSource.Items.AddRange(new object[] {
															   "",
															   "",
															   "",
															   "",
															   "",
															   "",
															   " ",
															   " ",
															   "",
															   "",
															   "",
															   ""});
			this.ListBoxSource.Location = new System.Drawing.Point(16, 32);
			this.ListBoxSource.Name = "ListBoxSource";
			this.ListBoxSource.Size = new System.Drawing.Size(120, 147);
			this.ListBoxSource.TabIndex = 0;
			this.ListBoxSource.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ListBoxSource_MouseDown);
			// 
			// ListBoxTarget
			// 
			this.ListBoxTarget.AllowDrop = true;
			this.ListBoxTarget.Location = new System.Drawing.Point(176, 32);
			this.ListBoxTarget.Name = "ListBoxTarget";
			this.ListBoxTarget.Size = new System.Drawing.Size(120, 147);
			this.ListBoxTarget.TabIndex = 1;
			this.ListBoxTarget.DragDrop += new System.Windows.Forms.DragEventHandler(this.ListBoxTarget_DragDrop);
			this.ListBoxTarget.DragEnter += new System.Windows.Forms.DragEventHandler(this.ListBoxTarget_DragEnter);
			// 
			// LabelDragSource
			// 
			this.LabelDragSource.AutoSize = true;
			this.LabelDragSource.Location = new System.Drawing.Point(16, 12);
			this.LabelDragSource.Name = "LabelDragSource";
			this.LabelDragSource.Size = new System.Drawing.Size(57, 16);
			this.LabelDragSource.TabIndex = 2;
			this.LabelDragSource.Text = ":";
			// 
			// LabelDropTarget
			// 
			this.LabelDropTarget.AutoSize = true;
			this.LabelDropTarget.Location = new System.Drawing.Point(176, 12);
			this.LabelDropTarget.Name = "LabelDropTarget";
			this.LabelDropTarget.Size = new System.Drawing.Size(64, 16);
			this.LabelDropTarget.TabIndex = 3;
			this.LabelDropTarget.Text = ":";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(312, 197);
			this.Controls.Add(this.LabelDropTarget);
			this.Controls.Add(this.LabelDragSource);
			this.Controls.Add(this.ListBoxTarget);
			this.Controls.Add(this.ListBoxSource);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.Text = "Drag and Drop Demo";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void ListBoxSource_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Point mouseLocation = new Point(e.X, e.Y);
			int selectedIndex = ListBoxSource.IndexFromPoint(mouseLocation);
			if (selectedIndex != -1)
			{
				string data = (string) ListBoxSource.Items[selectedIndex];
				ListBoxSource.DoDragDrop(data, DragDropEffects.Copy);
			}
		}

		private void ListBoxTarget_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			if (e.Data.GetDataPresent(DataFormats.UnicodeText))
			{
				e.Effect = DragDropEffects.Copy;
			}
		}

		private void ListBoxTarget_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			string data = (string) e.Data.GetData(DataFormats.UnicodeText);
			ListBoxTarget.Items.Add(data);
		}
	}
}
