using System;
using System.Windows.Forms;
using System.IO;

namespace Demo_7_MdiTextEditor
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu MainFormMenu;
		private System.Windows.Forms.ToolBar MainFormToolBar;
		private System.Windows.Forms.ImageList ToolBarImageList;
		private System.Windows.Forms.MenuItem FileMenuItem;
		private System.Windows.Forms.MenuItem FileNewMenuItem;
		private System.Windows.Forms.MenuItem FileOpenMenuItem;
		private System.Windows.Forms.MenuItem FileSaveMenuItem;
		private System.Windows.Forms.MenuItem FileSeperatorMenuItem;
		private System.Windows.Forms.MenuItem FileExitMenuItem;
		private System.Windows.Forms.MenuItem WindowMenuItem;
		private System.Windows.Forms.ToolBarButton NewToolBarButton;
		private System.Windows.Forms.ToolBarButton OpenToolBarButton;
		private System.Windows.Forms.ToolBarButton SaveToolBarButton;
		private System.Windows.Forms.OpenFileDialog OpenFileDialog;
		private System.Windows.Forms.StatusBar MainFormStatusBar;
		private System.Windows.Forms.StatusBarPanel InfoStatusBarPanel;
		private System.Windows.Forms.StatusBarPanel LineStatusBarPanel;
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.MainFormMenu = new System.Windows.Forms.MainMenu();
			this.FileMenuItem = new System.Windows.Forms.MenuItem();
			this.FileNewMenuItem = new System.Windows.Forms.MenuItem();
			this.FileOpenMenuItem = new System.Windows.Forms.MenuItem();
			this.FileSaveMenuItem = new System.Windows.Forms.MenuItem();
			this.FileSeperatorMenuItem = new System.Windows.Forms.MenuItem();
			this.FileExitMenuItem = new System.Windows.Forms.MenuItem();
			this.WindowMenuItem = new System.Windows.Forms.MenuItem();
			this.MainFormToolBar = new System.Windows.Forms.ToolBar();
			this.NewToolBarButton = new System.Windows.Forms.ToolBarButton();
			this.OpenToolBarButton = new System.Windows.Forms.ToolBarButton();
			this.SaveToolBarButton = new System.Windows.Forms.ToolBarButton();
			this.ToolBarImageList = new System.Windows.Forms.ImageList(this.components);
			this.OpenFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.MainFormStatusBar = new System.Windows.Forms.StatusBar();
			this.InfoStatusBarPanel = new System.Windows.Forms.StatusBarPanel();
			this.LineStatusBarPanel = new System.Windows.Forms.StatusBarPanel();
			((System.ComponentModel.ISupportInitialize)(this.InfoStatusBarPanel)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.LineStatusBarPanel)).BeginInit();
			this.SuspendLayout();
			// 
			// MainFormMenu
			// 
			this.MainFormMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.FileMenuItem,
																						 this.WindowMenuItem});
			// 
			// FileMenuItem
			// 
			this.FileMenuItem.Index = 0;
			this.FileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.FileNewMenuItem,
																						 this.FileOpenMenuItem,
																						 this.FileSaveMenuItem,
																						 this.FileSeperatorMenuItem,
																						 this.FileExitMenuItem});
			this.FileMenuItem.Text = "File";
			// 
			// FileNewMenuItem
			// 
			this.FileNewMenuItem.Index = 0;
			this.FileNewMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.FileNewMenuItem.Text = "New";
			this.FileNewMenuItem.Click += new System.EventHandler(this.FileNewMenuItem_Click);
			// 
			// FileOpenMenuItem
			// 
			this.FileOpenMenuItem.Index = 1;
			this.FileOpenMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.FileOpenMenuItem.Text = "Open...";
			this.FileOpenMenuItem.Click += new System.EventHandler(this.FileOpenMenuItem_Click);
			// 
			// FileSaveMenuItem
			// 
			this.FileSaveMenuItem.Index = 2;
			this.FileSaveMenuItem.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.FileSaveMenuItem.Text = "Save";
			this.FileSaveMenuItem.Click += new System.EventHandler(this.FileSaveMenuItem_Click);
			// 
			// FileSeperatorMenuItem
			// 
			this.FileSeperatorMenuItem.Index = 3;
			this.FileSeperatorMenuItem.Text = "-";
			// 
			// FileExitMenuItem
			// 
			this.FileExitMenuItem.Index = 4;
			this.FileExitMenuItem.Shortcut = System.Windows.Forms.Shortcut.AltF4;
			this.FileExitMenuItem.Text = "Exit";
			this.FileExitMenuItem.Click += new System.EventHandler(this.FileExitMenuItem_Click);
			// 
			// WindowMenuItem
			// 
			this.WindowMenuItem.Index = 1;
			this.WindowMenuItem.MdiList = true;
			this.WindowMenuItem.Text = "Window";
			// 
			// MainFormToolBar
			// 
			this.MainFormToolBar.AutoSize = false;
			this.MainFormToolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																							   this.NewToolBarButton,
																							   this.OpenToolBarButton,
																							   this.SaveToolBarButton});
			this.MainFormToolBar.DropDownArrows = true;
			this.MainFormToolBar.ImageList = this.ToolBarImageList;
			this.MainFormToolBar.Location = new System.Drawing.Point(0, 0);
			this.MainFormToolBar.Name = "MainFormToolBar";
			this.MainFormToolBar.ShowToolTips = true;
			this.MainFormToolBar.Size = new System.Drawing.Size(552, 28);
			this.MainFormToolBar.TabIndex = 0;
			this.MainFormToolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.MainFormToolBar_ButtonClick);
			// 
			// NewToolBarButton
			// 
			this.NewToolBarButton.ImageIndex = 0;
			// 
			// OpenToolBarButton
			// 
			this.OpenToolBarButton.ImageIndex = 1;
			// 
			// SaveToolBarButton
			// 
			this.SaveToolBarButton.ImageIndex = 2;
			// 
			// ToolBarImageList
			// 
			this.ToolBarImageList.ImageSize = new System.Drawing.Size(16, 16);
			this.ToolBarImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ToolBarImageList.ImageStream")));
			this.ToolBarImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// OpenFileDialog
			// 
			this.OpenFileDialog.Filter = "Text files (*.txt)|*.txt";
			this.OpenFileDialog.Title = "Choose text file";
			// 
			// MainFormStatusBar
			// 
			this.MainFormStatusBar.Location = new System.Drawing.Point(0, 387);
			this.MainFormStatusBar.Name = "MainFormStatusBar";
			this.MainFormStatusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																								 this.InfoStatusBarPanel,
																								 this.LineStatusBarPanel});
			this.MainFormStatusBar.ShowPanels = true;
			this.MainFormStatusBar.Size = new System.Drawing.Size(552, 22);
			this.MainFormStatusBar.TabIndex = 2;
			// 
			// InfoStatusBarPanel
			// 
			this.InfoStatusBarPanel.Width = 300;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 409);
			this.Controls.Add(this.MainFormStatusBar);
			this.Controls.Add(this.MainFormToolBar);
			this.IsMdiContainer = true;
			this.Menu = this.MainFormMenu;
			this.Name = "MainForm";
			this.Text = "Text Editor Demo";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.InfoStatusBarPanel)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.LineStatusBarPanel)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			SetInfoStatusBar("Application started.");
		}

		public void SetInfoStatusBar(string aText)
		{
			InfoStatusBarPanel.Text = aText;
		}

		public void SetLineStatusBar(string aText)
		{
			LineStatusBarPanel.Text = aText;
		}

		private void FileNewMenuItem_Click(object sender, System.EventArgs e)
		{
			CreateNewFile();
		}

		private void FileOpenMenuItem_Click(object sender, System.EventArgs e)
		{
			OpenExistingFile();
		}

		private void FileSaveMenuItem_Click(object sender, System.EventArgs e)
		{
			SaveCurrentFile();
		}

		private void FileExitMenuItem_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void MainFormToolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == NewToolBarButton)
			{
				CreateNewFile();
			}
			else if (e.Button == OpenToolBarButton)
			{
				OpenExistingFile();
			}			
			else if (e.Button == SaveToolBarButton)
			{
				SaveCurrentFile();
			}
		}

		private void CreateNewFile()
		{
			EditorForm editorForm = new EditorForm();
			editorForm.MdiParent = this;
			editorForm.CreateNewFile();
			editorForm.Show();
		}

		private void OpenExistingFile()
		{
			if (OpenFileDialog.ShowDialog() != DialogResult.OK)
			{
				return;
			}

			string fileName = OpenFileDialog.FileName;
			
			EditorForm editorForm = new EditorForm();
			try
			{
				editorForm.LoadFile(fileName);
				editorForm.MdiParent = this;
				editorForm.Show();
				SetInfoStatusBar("Loaded file: " + fileName);
			}
			catch (IOException)
			{
				editorForm.Dispose();
				MessageBox.Show("Can not load file: " + fileName, "Error");
			}
		}

		private void SaveCurrentFile()
		{
			EditorForm activeEditorForm = (EditorForm) this.ActiveMdiChild;
			if (activeEditorForm != null)
			{
				activeEditorForm.Save();
			}
		}
	}
}
