using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Demo_9_Binding_Control_To_Object
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox TextBoxCustomerName;
		private System.Windows.Forms.Button ButtonShowCustomer;
		private System.Windows.Forms.Button ButtonChangeCustomer;
		private System.Windows.Forms.Button ButtonRebind;

		private Customer mCustomer;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.TextBoxCustomerName = new System.Windows.Forms.TextBox();
			this.ButtonShowCustomer = new System.Windows.Forms.Button();
			this.ButtonChangeCustomer = new System.Windows.Forms.Button();
			this.ButtonRebind = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// TextBoxCustomerName
			// 
			this.TextBoxCustomerName.Location = new System.Drawing.Point(24, 24);
			this.TextBoxCustomerName.Name = "TextBoxCustomerName";
			this.TextBoxCustomerName.Size = new System.Drawing.Size(208, 20);
			this.TextBoxCustomerName.TabIndex = 0;
			this.TextBoxCustomerName.Text = "";
			// 
			// ButtonShowCustomer
			// 
			this.ButtonShowCustomer.Location = new System.Drawing.Point(64, 64);
			this.ButtonShowCustomer.Name = "ButtonShowCustomer";
			this.ButtonShowCustomer.Size = new System.Drawing.Size(128, 23);
			this.ButtonShowCustomer.TabIndex = 1;
			this.ButtonShowCustomer.Text = "Show Customer";
			this.ButtonShowCustomer.Click += new System.EventHandler(this.ButtonShowCustomer_Click);
			// 
			// ButtonChangeCustomer
			// 
			this.ButtonChangeCustomer.Location = new System.Drawing.Point(64, 104);
			this.ButtonChangeCustomer.Name = "ButtonChangeCustomer";
			this.ButtonChangeCustomer.Size = new System.Drawing.Size(128, 23);
			this.ButtonChangeCustomer.TabIndex = 2;
			this.ButtonChangeCustomer.Text = "Change Customer";
			this.ButtonChangeCustomer.Click += new System.EventHandler(this.ButtonChangeCustomer_Click);
			// 
			// ButtonRebind
			// 
			this.ButtonRebind.Location = new System.Drawing.Point(64, 144);
			this.ButtonRebind.Name = "ButtonRebind";
			this.ButtonRebind.Size = new System.Drawing.Size(128, 23);
			this.ButtonRebind.TabIndex = 3;
			this.ButtonRebind.Text = "Rebind";
			this.ButtonRebind.Click += new System.EventHandler(this.ButtonRebind_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(256, 181);
			this.Controls.Add(this.ButtonRebind);
			this.Controls.Add(this.ButtonChangeCustomer);
			this.Controls.Add(this.ButtonShowCustomer);
			this.Controls.Add(this.TextBoxCustomerName);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.Text = "Binding Control To Object";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			mCustomer = new Customer();
			mCustomer.Name = " ";

			RebindFormControls();
		}

		private void ButtonShowCustomer_Click(object sender, System.EventArgs e)
		{
			string customerName = mCustomer.Name;
			MessageBox.Show(customerName);
		}

		private void ButtonChangeCustomer_Click(object sender, System.EventArgs e)
		{
			mCustomer.Name = " ";
		}

		private void ButtonRebind_Click(object sender, System.EventArgs e)
		{
			RebindFormControls();
		}

		private void RebindFormControls()
		{
			TextBoxCustomerName.DataBindings.Clear();
			TextBoxCustomerName.DataBindings.Add(
				new Binding("Text", mCustomer, "Name"));
		}
	}

	class Customer
	{
		private string mName;
		public string Name
		{
			get { return mName; }
			set { mName = value; }
		}
	}

}
